Subject: RE: [Sigtran] Open Issue 3rd M3UA Plugtest: NTFY

From: "Javier Pastor-Balbas (ECE)" <[email-masked]>
Date: Wed, 11 Dec 2002 12:29:04 +0100

Brian, 

I'm just trying to find out why people have so many problems in understanding when NTFY is mandatory and when not... And specially finding a solution to avoid it. We had discussions whether put must or MUST in more than one ocassion. And my perception is that "must" is not as clear as "MUST".

On the other hand one of the purposes of the Plugtest is making sure that all the people reading the spec have a common understanding. In this case as the common understanding has not got, we have to fix the document in order to achieve it.

From your mails I infer that you prefer not to change the document and leave NTFY wordings as they are. Since there were several people in the bake-off stating the opposite, I think that the issue is still open and needs a solution. For sure having all the reqs and uses of NTFY spreaded along all the section does not help...

IMHO, a good solution would be to put all the NTFY reqs together and with a common notation to make it clear whether this message is mandatory or not.

I appreciate your valuable feedback (comments below). :-)

Thanks  // Javier.

> -----Original Message-----
> From: Brian F. G. Bidulock [mailto:[email-masked]]
> Sent: Wednesday, December 11, 2002 10:56 AM
> To: Javier Pastor-Balbas (ECE)
> Cc: 'Tolga Asveren'; [email-masked]
> Subject: Re: [Sigtran] Open Issue 3rd M3UA Plugtest: NTFY
> 
> 
> Javier,
> 
> There is no difference between "must" and "MUST".  Both have the
> same force and effect.  At least that's what Scott tells us, and
> since he wrote the RFC on it, he must/MUST be right.
> 
> Although these keywords are usually capitalized, not capitalizing
> them does not lessen their effect.
> 
It is not that clear... People may get confused...

> Besides, I'm sure Tolga was referring to section 4.3.4.3 which says:
> 
> 	" ... The SGP or IPSP then MUST send a Notify message
> 	 ("Alternate ASP_Active") to the previously active ASP in
> 	 the AS, and SHOULD stop traffic to/from that ASP. ... "
> 
> I think this is fairly clear that sending of "Alternate ASP Active"
> is a MUST.
> 

I agree, but it is not easy to find it. It is out of the NTFY procedures section...

> --brian
> 
> Javier Pastor-Balbas (ECE) wrote:                (Wed, 11 Dec 
> 2002 10:21:12)
> > Hi Tolga, 
> > 
> > I don't consider that sending NTFY when "Alternate ASP 
> Active" is said to be
> > a MUST. This case does not imply an AS state change. And 
> the only MUST for
> > the NTFY section is for that case.
> > 
> > The sentence that you mention is within the first paragraph 
> in section
> > 3.4.4.5 what talks about the fact that NTFY MUST be sent 
> when an AS state
> > change happens. This may be due to ASPSM arrival or ASP 
> failure. But it may
> > happens that an ASP fails and the AS state does not change. 
> This case does
> > not force to send NTFY. The "must" was not capitalized to 
> show that this
> > sentence was not a new requirement, but it was inside the 
> main one: AS state
> > change.
> > 
> > 
> > Cheers // Javier.
> > 
> > 
> > > -----Original Message-----
> > > From: Tolga Asveren [mailto:[email-masked]]
> > > Sent: Tuesday, December 10, 2002 3:56 PM
> > > To: [email-masked]
> > > Subject: RE: [Sigtran] Open Issue 3rd M3UA Plugtest: NTFY
> > > 
> > > 
> > > Hi Javier,
> > > --- "Javier Pastor-Balbas (ECE)"
> > > <[email-masked]> wrote:
> > > > Hi Tolga et al., 
> > > > 
> > > > You are right. But I see the contradiction between
> > > > "MAY" and "required". When is sending that message
> > > > required? Is it required but optional (we use MAY)
> > > > at the same time? I'm afraid that "required" has
> > > > been historically kept from a previous version where
> > > > MAY was MUST... With the current wording, I'd
> > > > suggest to remove it.
> > > [TOLGA] I also would think MAY already indicates "if
> > > required", so removing is fine IMO.
> > > > 
> > > > If we state that NTFY is compulsory for the "AS
> > > > state changes" but optional for "other cases", we
> > > > should indicate it clearly in the NTFY section. It
> > > > may be easily included in the first sentence. I
> > > > think this could help for a better understanding.
> > > [TOLGA] There are also other cases, where sending NTFY
> > > is a MUST. For example for "Alternate ASP Active". I
> > > am not sure but I think also for "ASP Failure"(related
> > > with this I could find the following sentence in
> > > 4.3.4.5 
> > > "The Notify message must be sent whether the AS state
> > > change was a result of an ASP failure or reception of
> > > an ASP State management (ASPSM) / ASP Traffic
> > > Management (ASPTM) message." 
> > > The "must" in this sentence is not a "MUST" but I
> > > don't know, whether this is on intention. 
> > > So, it seems only "Insufficient ASP Resources Active"
> > > is a MAY, the rest is MUST.
> > > > 
> > > > Any comments on this?  
> > > > 
> > > > Are there any additional comments from the people
> > > > attending the Plugtest on this issue?
> > > > 
> > > > 
> > > > Cheers // Javier.
> > > > 
> > > > 
> > > > > -----Original Message-----
> > > > > From: Tolga Asveren
> > > > [mailto:[email-masked]]
> > > > > Sent: Monday, December 09, 2002 11:54 PM
> > > > > To: [email-masked]
> > > > > Subject: Re: [Sigtran] Open Issue 3rd M3UA
> > > > Plugtest: NTFY
> > > > > 
> > > > > 
> > > > > Hi Javier,
> > > > > --- "Javier Pastor-Balbas (ECE)"
> > > > > <[email-masked]> wrote:
> > > > > > Hi guys, 
> > > > > > 
> > > > > > During the last M3UA Plugtest, there was a doubt
> > > > > > whether NTFY is mandatory in all the cases or
> > > > not.
> > > > > > The RFC clearly indicates that it is in the NTFY
> > > > > > Procedures Section (4.3.4.5). But there are some
> > > > > > wordings in the ASP Inactive (4.3.4.4.)where it
> > > > is
> > > > > > said that: 
> > > > > [TOLGA] 4.3.4.5 says that sending NTFY is a MUST,
> > > > when
> > > > > AS state changes. NTFY("Insufficient ASP resources
> > > > > active in AS") does not indicate an AS state
> > > > change.
> > > > > So, I would think that there is no contradiction.
> > > > > > 
> > > > > >   "A Notify message ("Insufficient ASP resources
> > > > > > active in AS") MAY be sent to allinactive ASPs,
> > > > if
> > > > > > required"
> > > > > >                                                 
> > > >    
> > > > > >            ^^^
> > > > > > I propose to change the "MAY" into "MUST" to
> > > > align
> > > > > > it with the procedures described in 4.3.4.5
> > > > > > 
> > > > > > Also some examples have to be update to include
> > > > the
> > > > > > NTFY whenever it is missing: 5.1.3 and 5.2.1
> > > > > > 
> > > > > > 
> > > > > > Comments?
> > > > > > 
> > > > > > 
> > > > > > Cheers // Javier.
> > > > > > _______________________________________________
> > > > > > Sigtran mailing list
> > > > > > [email-masked]
> > > > > > https://www1.ietf.org/mailman/listinfo/sigtran
> > > > > 
> > > > > 
> > > > > __________________________________________________
> > > > > Do you Yahoo!?
> > > > > Yahoo! Mail Plus - Powerful. Affordable. Sign up
> > > > now.
> > > > > http://mailplus.yahoo.com
> > > > > _______________________________________________
> > > > > Sigtran mailing list
> > > > > [email-masked]
> > > > > https://www1.ietf.org/mailman/listinfo/sigtran
> > > > > 
> > > 
> > > 
> > > __________________________________________________
> > > Do you Yahoo!?
> > > Yahoo! Mail Plus - Powerful. Affordable. Sign up now.
> > > http://mailplus.yahoo.com
> > > _______________________________________________
> > > Sigtran mailing list
> > > [email-masked]
> > > https://www1.ietf.org/mailman/listinfo/sigtran
> > > 
> > _______________________________________________
> > Sigtran mailing list
> > [email-masked]
> > https://www1.ietf.org/mailman/listinfo/sigtran
> 
> -- 
> Brian F. G. Bidulock
> [email-masked]
> http://www.openss7.org/
> 
_______________________________________________
Sigtran mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/sigtran

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 11 Dec 2002 05:02:25 -0700

Javier,

Javier Pastor-Balbas (ECE) wrote:                 (Wed, 11 Dec 2002 12:29:04)
> Brian, 
> 
> I'm just trying to find out why people have so many problems in
> understanding when NTFY is mandatory and when not... And specially finding a
> solution to avoid it. We had discussions whether put must or MUST in more
> than one ocassion. And my perception is that "must" is not as clear as
> "MUST".
> 
> On the other hand one of the purposes of the Plugtest is making sure that
> all the people reading the spec have a common understanding. In this case as
> the common understanding has not got, we have to fix the document in order
> to achieve it.
> 
> From your mails I infer that you prefer not to change the document and
> leave NTFY wordings as they are. Since there were several people in the
> bake-off stating the opposite, I think that the issue is still open and
> needs a solution. For sure having all the reqs and uses of NTFY spreaded
> along all the section does not help...
> 
> IMHO, a good solution would be to put all the NTFY reqs together and with a
> common notation to make it clear whether this message is mandatory or not.

Let those who want changes propose text, and let them propose it here.

The only text proposal we have seen is changing MAY to MUST in section
4.3.4.4, which is unacceptable for the reasons already stated (the SGP might
not know the value of "n" because it does not appear in any message, as does,
for example, traffic mode).  We discussed adding "n" to traffic mode in ASPTM,
but it was rejected and so we make the NTFY a MAY instead of a MUST.

If you want to rewrite the Notify section, it should be done for M2UA and
SUA as well (because these share the common text).  It is probably outside
the scope of the M3UA IG to rewrite entire sections of the text for M2UA,
M3UA and SUA.  So, if the changes are extensive, it would be better in a
separate draft.

If the changes are minor, and can be pulled into the M2UA IG, the M3UA IG
and the SUA IG easily enough, let us see the text proposal in the WG.

> It is not that clear... People may get confused...

Scott's last note on the subject was clear as mud.  If RFC 2119 is not
clear to them, let them ask the author (as I did) or discuss it in the
appropriate working group.  (I have attached Scott's note on the subject
to this working group from January of this year.)

Changing the "must" to "MUST" and "should" to "SHOULD" was something
that the editors should have done before the RFC went to press.

You could put in the IG that all "must"s are to be interpreted as
"MUST"s, but the reference to RFC 2119 already accomplishes this.
RFC 2119 says that "These words are often capitalized." but there
is no requirement in the RFC to do so.

> I agree, but it is not easy to find it. It is out of the NTFY procedures

RFCs are published as text documents so that simple text-based
tools can be used to search them.  If you search on "Alternate" you
will find only four occurences in the document, three close together
in the Notify message description section, and the fourth in the
passage cited.  It took me about 200ms to find this passage.
Moving it will not decrease the search time significantly.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

Subject: Re: Difference between SHOULD NOT and should not
From: Scott Bradner <[email-masked]>
To: "sigtran" <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Wed, 9 Jan 2002 09:03:05 -0500 (EST)

> I still could not get an answer to my question. Plain english means the
> words are of no use as far as implementation is considered. How do we decide
> what is MUST if small must is plain english?

if the text says you must do X or says you MUST do x the result is the
same - you must do x - that is what I meant by its plain englisg

the reason to use MUST is for emphasis and clarity but plain text can
be just as clear if it is crefully written

Scott

---
You are currently subscribed to sigtran as: [email-masked]
To unsubscribe send a blank email to [email-masked]